#include <stdlib.h>
#include <stream.h>
#include <math.h>

#define MAXSTR 1024

int main(int argc, char **argv)
{
  float header[512];
  int m,n,k,r;
  int i,j,l,q;
  int m0,n0,k0,r0,d0;
  int newformat=0;
  float *data=NULL;
  float *s1;
  float *s2;
  float *s3;
  float *a;
  float z;
  FILE *fr;
  FILE *fp;
  char fpname[MAXSTR];
  char foname[MAXSTR];
  char frname[MAXSTR];
  char fake;
  char iline[MAXSTR];
  
/*  cout<<"Input full data sizes (multiply indirect dimensions by 2 to account for Re and IM FIDs)\n";
  cout<<"Dimension X: ";
  cin>>m;
  cout<<"Dimension Y: ";
  cin>>n;
  cout<<"Dimension Z: ";
  cin>>k;
  cout<<"Number of components: ";
  cin>>r;
  
  cout<<"NMRPipe stream template file (i.e. not plane files of pipe2xyz!): ";
  cin>>fpname;
  cout<<"Core name for shape files: ";
  cin>>cname;
  cout<<"NMRPipe stream output file: ";
  cin>>foname;*/
  if (argc!=4) {
    cout<<"Usage: res2pipe <nmrPipe stream> <result of MDD> <nmrPipe output>\n";
    cout<<"                <nmrPipe stream> - file (not planes!) used to create MDD input\n";
    cout<<"                <result of MDD>  - res.dat (or it's alias), i.e. the result of MDD calculation\n";
    cout<<"                <nmrPipe output> - output file with reconstructed (but not FT'ed) spectrum\n";
    exit(1);
  }
  
  strcpy(fpname,argv[1]);
  strcpy(frname,argv[2]);
  strcpy(foname,argv[3]);
  
  if (NULL==(fp=fopen(fpname,"rb"))) {
    cerr<<"Could not open file "<<fpname<<" for reading. Exiting...\n";
    exit(1);
  }
  if (512!=fread(header,sizeof(float),512,fp)) {
    cerr<<"Could not read 512 floats into header from file "<<fpname<<". Exiting...\n";
    exit(1);
  }  
  k=header[15];    // dim 3 size
  n=header[428]*2; // dim 2 size
  m=header[99];    // dim 1 size
  if (NULL==(fr=fopen(frname,"r"))) {
    cout<<"Could not open file "<<frname<<". Exiting...\n";
    exit(1);
  }

  //***************** Checking for sizes from res.dat ****************

  q=0;
  if (1==fscanf(fr,"%f",&z)) q++;
  else {
    newformat=1;
    do {
      fscanf(fr,"%c",&fake);
    }
    while ('$'!=fake);
    if (5!=fscanf(fr,"%d %*d %d %d %d %d",&d0,&r0,&m0,&n0,&k0)) {
      cout<<"Could not read number of dimensions from result file "<<frname<<". Exiting...\n";
      exit(4);
    }
    else {
      if (d0!=3) {
        cout<<"Result file "<<frname<<" indicates "<<d0<<" dimensions. Currently only 3D spectra are supported. Exiting...\n";
        exit(4);
      }
      if (m!=m0 || n!=n0 || k!=k0) {
        cout<<"Result file "<<frname<<" and nmrPipe file "<<fpname<<" indicate inconsistent dimension sizes. Exiting...\n";
        exit(4);
      }
    }
    
  }
    
  while(1==fscanf(fr,"%f",&z)) q++;
  
  r=q/(m+n+k+1);
  if ((newformat && (r!=r0)) || (q-r*(m+n+k+1) != 0)) {
    cout<<"Result file "<<frname<<" and nmrPipe file "<<fpname<<" seem to have inconsistent size parameters. Exiting...\n";
    exit(4);
  }
  rewind(fr); 
  
  // ******************** Reading the res.dat ********************
  if (newformat) {
    do {
      fscanf(fr,"%c",&fake);
    }
    while ('$'!=fake);
    fscanf(fr,"%*d %*d %*d %*d %*d %*d");
  }

  // ***************** Memory allocations ******************
  if (NULL==(s1=new float[m*r])) {
    cerr<<"Could not allocate "<<m*r*4<<" bytes of memory to store shape s1. Exiting...\n";
    exit(2);
  }
  if (NULL==(s2=new float[n*r])) {
    cerr<<"Could not allocate "<<n*r*4<<" bytes of memory to store shape s2. Exiting...\n";
    exit(2);
  }
  if (NULL==(s3=new float[k*r])) {
    cerr<<"Could not allocate "<<k*r*4<<" bytes of memory to store shape s3. Exiting...\n";
    exit(2);
  }
  if (NULL==(a=new float[r])) {
    cerr<<"Could not allocate "<<r*4<<" bytes of memory to store amplitudes. Exiting...\n";
    exit(2);
  }

  // ******************** Reading the actual data *********************
  if (newformat) {
    // In new format amplitudes come first
    for (j=0; j<r; j++)
      fscanf(fr,"%f",a+j);
    for (i=0; i<m; i++)
      for (j=0; j<r; j++)
        if (1!=fscanf(fr,"%f",s1+i*r+j)) {
          cout<<"Could not read "<<i<<" element of "<<j<<" component (shape 1) from file "<<frname<<"\n";
	  exit(3);
        }
    for (i=0; i<n; i++)
      for (j=0; j<r; j++)
        if (1!=fscanf(fr,"%f",s2+i*r+j)) {
          cout<<"Could not read "<<i<<" element of "<<j<<" component (shape 2) from file "<<frname<<"\n";
	  exit(3);
        }
    for (i=0; i<k; i++)
      for (j=0; j<r; j++)
        if (1!=fscanf(fr,"%f",s3+i*r+j)) {
          cout<<"Could not read "<<i<<" element of "<<j<<" component (shape 3) from file "<<frname<<"\n";
	  exit(3);
        }
  }
  else {
    // In old format amplitudes come last
    for (i=0; i<m; i++)
      for (j=0; j<r; j++)
        if (1!=fscanf(fr,"%f",s1+i*r+j)) {
          cout<<"Could not read "<<i<<" element of "<<j<<" component (shape 1) from file "<<frname<<"\n";
	  exit(3);
        }
    for (i=0; i<n; i++)
      for (j=0; j<r; j++)
        if (1!=fscanf(fr,"%f",s2+i*r+j)) {
          cout<<"Could not read "<<i<<" element of "<<j<<" component (shape 2) from file "<<frname<<"\n";
	  exit(3);
        }
    for (i=0; i<k; i++)
      for (j=0; j<r; j++)
        if (1!=fscanf(fr,"%f",s3+i*r+j)) {
          cout<<"Could not read "<<i<<" element of "<<j<<" component (shape 3) from file "<<frname<<"\n";
	  exit(3);
        }
    for (j=0; j<r; j++)
      fscanf(fr,"%f",a+j);
  }
  fclose(fr);
 
  cout<<"Sizes are X: "<<m<<"; Y: "<<n<<"; Z: "<<k<<"; Number of components: "<<r<<"\n";
 
  if (NULL==(data=new float[m*n*k])) {
    cerr<<"Could not allocate "<<m*n*k*4<<" bytes of memory to store data. Exiting...\n";
    exit(1);
  }
  
  
  if (m*n*k!=fread(data,sizeof(float),m*n*k,fp)) {    
    cerr<<"Could not read "<<m*n*k<<" floats of data from file "<<fpname<<". Exiting...\n";
    exit(1);
  }
  if (0<fread(&fake,1,1,fp)) {
    cerr<<"There is still data in file "<<fpname<<" although "<<512+m*n*k<<" floats of header and data were read. Exiting..\n";
    exit(1);
  }
  fclose(fp);
  
  
  
  
  for (i=0; i<k; i++) 
    for (j=0; j<n; j++) 
      for (l=0; l<m; l++) 
        if (fabs(data[i*m*n+j*m+l])<1e-6) {
	  data[i*m*n+j*m+l]=0;
	  for (q=0; q<r; q++) 
	    data[i*m*n+j*m+l]+=a[q]*s1[l*r+q]*s2[j*r+q]*s3[i*r+q];
	}
  
  if (NULL==(fp=fopen(foname,"wb"))) {
    cerr<<"Could not open file "<<foname<<" for writing. Exiting...\n";
    exit(1);
  }
  if (512!=fwrite(header,sizeof(float),512,fp)) {
    cerr<<"Could not write 512 floats of header into file "<<foname<<". Exiting...\n";
    exit(1);
  }
  if (m*n*k!=fwrite(data,sizeof(float),m*n*k,fp)) {    
    cerr<<"Could not write "<<m*n*k<<" floats of data into file "<<foname<<". Exiting...\n";
    exit(1);
  }
  
  fclose(fp);
  
  cerr<<"done...\n";
  return 0;
}
